/*
Copyright 2020 caicloud authors. All rights reserved.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "github.com/caicloud/cyclone/pkg/apis/cyclone/v1alpha1"
	scheme "github.com/caicloud/cyclone/pkg/k8s/clientset/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// WorkflowTriggersGetter has a method to return a WorkflowTriggerInterface.
// A group's client should implement this interface.
type WorkflowTriggersGetter interface {
	WorkflowTriggers(namespace string) WorkflowTriggerInterface
}

// WorkflowTriggerInterface has methods to work with WorkflowTrigger resources.
type WorkflowTriggerInterface interface {
	Create(ctx context.Context, workflowTrigger *v1alpha1.WorkflowTrigger, opts v1.CreateOptions) (*v1alpha1.WorkflowTrigger, error)
	Update(ctx context.Context, workflowTrigger *v1alpha1.WorkflowTrigger, opts v1.UpdateOptions) (*v1alpha1.WorkflowTrigger, error)
	UpdateStatus(ctx context.Context, workflowTrigger *v1alpha1.WorkflowTrigger, opts v1.UpdateOptions) (*v1alpha1.WorkflowTrigger, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.WorkflowTrigger, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.WorkflowTriggerList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.WorkflowTrigger, err error)
	WorkflowTriggerExpansion
}

// workflowTriggers implements WorkflowTriggerInterface
type workflowTriggers struct {
	client rest.Interface
	ns     string
}

// newWorkflowTriggers returns a WorkflowTriggers
func newWorkflowTriggers(c *CycloneV1alpha1Client, namespace string) *workflowTriggers {
	return &workflowTriggers{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the workflowTrigger, and returns the corresponding workflowTrigger object, and an error if there is any.
func (c *workflowTriggers) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.WorkflowTrigger, err error) {
	result = &v1alpha1.WorkflowTrigger{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("workflowtriggers").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of WorkflowTriggers that match those selectors.
func (c *workflowTriggers) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.WorkflowTriggerList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.WorkflowTriggerList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("workflowtriggers").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested workflowTriggers.
func (c *workflowTriggers) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("workflowtriggers").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a workflowTrigger and creates it.  Returns the server's representation of the workflowTrigger, and an error, if there is any.
func (c *workflowTriggers) Create(ctx context.Context, workflowTrigger *v1alpha1.WorkflowTrigger, opts v1.CreateOptions) (result *v1alpha1.WorkflowTrigger, err error) {
	result = &v1alpha1.WorkflowTrigger{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("workflowtriggers").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(workflowTrigger).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a workflowTrigger and updates it. Returns the server's representation of the workflowTrigger, and an error, if there is any.
func (c *workflowTriggers) Update(ctx context.Context, workflowTrigger *v1alpha1.WorkflowTrigger, opts v1.UpdateOptions) (result *v1alpha1.WorkflowTrigger, err error) {
	result = &v1alpha1.WorkflowTrigger{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("workflowtriggers").
		Name(workflowTrigger.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(workflowTrigger).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *workflowTriggers) UpdateStatus(ctx context.Context, workflowTrigger *v1alpha1.WorkflowTrigger, opts v1.UpdateOptions) (result *v1alpha1.WorkflowTrigger, err error) {
	result = &v1alpha1.WorkflowTrigger{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("workflowtriggers").
		Name(workflowTrigger.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(workflowTrigger).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the workflowTrigger and deletes it. Returns an error if one occurs.
func (c *workflowTriggers) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("workflowtriggers").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *workflowTriggers) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("workflowtriggers").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched workflowTrigger.
func (c *workflowTriggers) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.WorkflowTrigger, err error) {
	result = &v1alpha1.WorkflowTrigger{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("workflowtriggers").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
